
domain {
   types { Block }

   world {
   }

   state {
      predicate OnTable(Block);
      predicate On(Block, Block);
      predicate Top(Block);
      predicate HandHas(Block);
      predicate HandFree();
      predicate sync();
   }

   action UnStack(Block a, Block b){
       duration:
          constant 1;
       conditions:
          @start: Top(a);
          @start: On(a,b);
          @start: HandFree();
          @overall: sync();
       effects:
          @end: HandHas(a);
          @end: !Top(a);
          @end: Top(b);
          @end: On(a,b);
          @end: !HandFree();
          @end: sync();
   }

   action Stack(Block a, Block b){
      duration:
         constant 1;
      conditions:
         @start: Top(b);
         @start: HandHas(a);
         @overall: sync();
      effects:
         @end: !HandFree();
         @end: On(a, b);
         @end: Top(a);
         @end: !Top(b);
         @end: HandHas(a);
         @end: sync();
   }

   action Drop(Block a){
      duration:
        constant 1;
      conditions:
        @start: HandHas(a);
        @overall: sync();
      effects:
        @end: OnTable(a);
        @end: Top(a);
        @end: HandFree();
        @end: !HandHas(a);
        @end: sync();
    }

   action Grasp(Block a){
      duration:
        constant 1;
      conditions:
        @start: OnTable(a);
        @start: HandFree();
        @start: Top(a);
        @overall: sync();
      effects:
        @end: !OnTable(a);
        @end: !Top(a);
        @end: !HandFree();
        @end: HandHas(a);
        @end: sync();
    }

}
