/*
  Simplified NASA EVA planning domain
  Eric.Beaudry@GMail.com
*/

domain {
   types { Crew, Camera, Location, Object, StationObject }

   // static world state
   world {
        function   Location    AIRLOCK();  // Input language does not support constants. "Constants" are simulated using 0-ary functions which are initiated in problem files.
   }

   // dynamic world state
   state {
		function  Location LocatedCrew(Crew)
		function  Location LocatedObject(Object)
 		function  Location LocatedCamera(Camera)
   }


/************************************
           A c t i o n s 
*************************************/

action Prepare_For_EVA(Crew ev, Safety_Tether st, Location loc) {
   duration:
	constant 300;
   conditons:
       @overall: LocatedCrew(ev)=loc;
	   @atstart:  AIRLOCK()=loc;
   effects:
	   @end: Prepared_for_EVA(ev);
}

action Install_Item_On(Crew ev, Cover item, Location loc, Camera receiver){
       duration:
          constant 600;
       conditions:
		  @overall: LocatedCrew(ev) = loc;
		  @oervall: LocatedCamera(receiver) = loc;
		  @start: Possesses(ev, item);
       effects:
          @end: !Possesses(ev, item);
		  @end: InstalledOn(item, receiver);
   }


}

