
domain {
   types { Location, Object }

   world {
      predicate Link(Location,Location);
      numeric   Distance(Location,Location);
   }

   state {
      predicate At(Location);
      predicate ObjectAt(Object, Location);
      predicate Has(Object);
      predicate HandFree();
      numeric   total();
   }

   action Goto(Location a, Location b){
       duration:
          constant Distance(a, b) / 1.0;
       conditions:
          @start: At(a);
          @start: Link(a, b);
       effects:
          @end: !At(a);
          @end: At(b);
          //@end: increase total() Distance(a, b);
   }

   action Load(Location p, Object o){
      duration:
         constant 30;
      conditions:
         @start: At(p);
         @start: ObjectAt(o, p);
         @start: HandFree();
      effects:
         @end: !HandFree();
         @end: ObjectAt(o, p);
         @end: Has(o);
   }

   action Unload(Location p, Object o){
      duration:
        constant 30;
      conditions:
        @start: At(p);
        @start: Has(o);
      effects:
        @end: !Has(o);
        @end: ObjectAt(o, p);
        @end: HandFree();
    }

}
