/*
 Simple Transport Domain
 Eric.Beaudry@USherbrooke.ca

*/

domain {
   types { Location, Object, Truck }

   world {
      predicate Link(Location,Location);
      numeric   Distance(Location,Location);
   }

   state {
      function  Location PosRobot(Truck);
      function  Location PosObject(Object);
      function  Truck    OnWhichTruck(Object);
   }


/************************************
           A c t i o n s 
*************************************/


   action Drive(Truck t, Location orig, Location dest){
       duration:
          normal 1.2 * Distance(orig, dest) Distance(orig, dest)*0.1;
		  //constant Distance(orig, dest);
/*	   cost : constant 0; */
       conditions:
		  @start: orig != dest;
          @start: PosRobot(t) = orig;
          @start: Link(orig, dest);
       effects:
          @end: PosRobot(t) = dest;
   }


   action Load(Truck t, Location l, Object o){
      duration:
         uniform 30 60;
      conditions:
         @overall: PosRobot(t) = l;
         @start: PosObject(o) = l;
         @start: OnWhichTruck(o) = undefined;
      effects:
         @end: PosObject(o) = undefined;
         @end: OnWhichTruck(o) = t;
   }

   action Unload(Truck t, Location l, Object o){
      duration:
         uniform 30 60;
      conditions:
        @overall: PosRobot(t) = l;
        @start: OnWhichTruck(o) = t;
        @start: PosObject(o) = undefined;
      effects:
        @end: PosObject(o) = l;
        @end: OnWhichTruck(o) = undefined;
    }

}

